function hdFeature = ScSR(model, ldFeature)

lambda = model.PARA.lambda;

% normalize the dictionary
norm_Dl = sqrt(sum(model.Dl.^2, 1)); 
Dl = model.Dl ./ repmat(norm_Dl, size(model.Dl, 1), 1);
hdFeature = zeros(size(model.Dh, 1), size(ldFeature, 2));

% normalize ldFeature
normld = sqrt(sum(ldFeature.^2, 1));
ldFeature = ldFeature ./ repmat(normld, size(ldFeature, 1), 1);

A = Dl'*Dl;

% loop to recover each low-resolution patch
for i = 1:size(ldFeature, 2),
    b = -Dl'*ldFeature(:,i);
    w = L1QP_FeatureSign_yang(lambda, A, b);
    hdFeature(:,i) = model.Dh*w;
end

end


