function feature2image()

featureFile = 'feature.mat';
outputdir = '.\midresult\';
hblockSize = 16;
nbPatchVer = 30;
nbPatchHor = 15;
dent = 4;

patchW = hblockSize * 3 + dent * 5;
patchH = hblockSize + dent;
nbPatchIm = nbPatchVer * nbPatchHor;
feature = load(featureFile);
nbFeature = size(feature.ceFeatureAll, 2);
nbim = max(floor(nbFeature / nbPatchIm), 10);
featureIdx = 1;
totalPatch = 0;
for i=0:(nbim-1)
    im = ones(patchH * nbPatchVer, patchW * nbPatchHor);
    for patchIdx = 0:(nbPatchIm-1)
        h = floor(patchIdx / nbPatchHor);
        w = patchIdx - h * nbPatchHor;
        while (featureIdx <= nbFeature) && ((var(feature.hdFeatureAll(:,featureIdx)) < 0.001) ||...
                (var(feature.hdFeatureAll(:,featureIdx)) > 1))    % sqrt(var) < 4
            featureIdx = featureIdx + 1;
        end
        if featureIdx > nbFeature
            break;
        end
        offset = [patchH * h, patchW * w];
        cpatch = mat2gray(reshape(feature.ceFeatureAll(:,featureIdx), hblockSize, hblockSize)');
        hdpatch = reshape(feature.hdFeatureAll(:,featureIdx), hblockSize, hblockSize)';
        ldpatch = reshape(feature.ldFeatureAll(:,featureIdx), hblockSize, hblockSize)';
        im(offset(1)+(1:hblockSize), offset(2)+(1:hblockSize)) = cpatch;
        im(offset(1)+(1:hblockSize), offset(2)+hblockSize+dent+(1:hblockSize)) = ldpatch;
%        im(offset(1)+(1:hblockSize), offset(2)+hblockSize*2+dent*2+(1:hblockSize)) = mat2gray(abs(hdpatch - ldpatch));
        im(offset(1)+(1:hblockSize), offset(2)+hblockSize*2+dent*2+(1:hblockSize)) = hdpatch;
        featureIdx = featureIdx + 1;
        totalPatch = totalPatch + 1;
    end
    imwrite(imresize(im, 3), sprintf('%s%d.bmp', outputdir, i));
    if featureIdx > nbFeature
        break;
    end
end

fprintf(1, '%d of %d display\n', totalPatch, nbFeature);

end

